#include "outputcsv.hh"
#include "request.hh"
#include "mobile.hh"

#include <sstream>

using namespace std ;



/* *** Operations *** */


const string OutputCSV::result_to_csv(const Result &result)
{
  ostringstream csv_line ;

  const Request *const request = result.get_request() ;
  if (request != NULL)
    {
      if (request->get_mobile() != NULL)
        csv_line << request->get_mobile()->get_mac_addr() ;
      csv_line << ';' << request->get_time_sent() ;
    }
  else
    csv_line << ';' ;

  Point3D position = result.get_position() ;
  csv_line
      << ';' << position.get_x()
      << ';' << position.get_y()
      << ';' << position.get_z() ;

  csv_line << '\n' ;
  return csv_line.str() ;
}
